Documents/DEV/portfolio-site/config/routes.rb
Rails.application.routes.draw do
  resources :topics, only: [:index, :show]

  devise_for :users, path: '', path_names: { sign_in: 'login', sign_out: 'logout', sign_up: 'register' }
  resources :portfolios, except: [:show] do
    put :sort, on: :collection
  end
  get 'angular-items', to: 'portfolios#angular'
  get 'portfolio/:id', to: 'portfolios#show', as: 'portfolio_show'

  get 'about-me', to: 'pages#about'
  get 'contact', to: 'pages#contact'
  get 'tech-news', to: 'pages#tech_news'

  resources :blogs do
    member do
      get :toggle_status
    end
  end

  mount ActionCable.server => '/cable'

  root to: 'pages#home'
end

Documents/DEV/portfolio-site/app/models/portfolio.rb
class Portfolio < ApplicationRecord
  has_many :technologies
  accepts_nested_attributes_for :technologies,
                                allow_destroy: true,
                                reject_if: lambda { |attrs| attrs['name'].blank? }

  validates_presence_of :title, :body

  mount_uploader :thumb_image, PortfolioUploader
  mount_uploader :main_image, PortfolioUploader

  def self.angular
    where(subtitle: 'Angular')
  end

  def self.by_position
    order("position ASC")
  end

  scope :ruby_on_rails_portfolio_items, -> { where(subtitle: 'Ruby on Rails') }
end

Documents/DEV/portfolio-site/app/controllers/portfolios_controller.rb
class PortfoliosController < ApplicationController
  before_action :set_portfolio_item, only: [:edit, :show, :update, :destroy]
  layout 'portfolio'
  access all: [:show, :index, :angular], user: {except: [:destroy, :new, :create, :update, :edit, :sort]}, site_admin: :all
  
  def index
    @portfolio_items = Portfolio.by_position
  end

  def sort
    params[:order].each do |key, value|
      Portfolio.find(value[:id]).update(position: value[:position])
    end

    render nothing: true
  end

  def angular
    @angular_portfolio_items = Portfolio.angular
  end

  def new
    @portfolio_item = Portfolio.new
  end

  def create
    @portfolio_item = Portfolio.new(portfolio_params)

    respond_to do |format|
      if @portfolio_item.save
        format.html { redirect_to portfolios_path, notice: 'Your portfolio item is now live.' }
      else
        format.html { render :new }
      end
    end
  end

  def edit
  end

  def update
    respond_to do |format|
      if @portfolio_item.update(portfolio_params)
        format.html { redirect_to portfolios_path, notice: 'The record successfully updated.' }
      else
        format.html { render :edit }
      end
    end
  end

  def show
  end

  def destroy
    # Destroy/delete the record
    @portfolio_item.destroy

    # Redirect
    respond_to do |format|
      format.html { redirect_to portfolios_url, notice: 'Record was removed.' }
    end
  end

  private

  def portfolio_params
    params.require(:portfolio).permit(:title,
                                      :subtitle,
                                      :body,
                                      :main_image,
                                      :thumb_image,
                                      technologies_attributes: [:id, :name, :_destroy]
                                     )
  end

  def set_portfolio_item
    @portfolio_item = Portfolio.find(params[:id])
  end
end

Documents/DEV/portfolio-site/app/helpers/portfolios_helper.rb
module PortfoliosHelper
  def image_generator(height:, width:)
    "http://placehold.it/#{height}x#{width}"
  end

  def portfolio_img img, type
    if img.model.main_image? || img.model.thumb_image?
      img
    elsif type == 'thumb'
      image_generator(height: '350', width: '200')
    elsif type == 'main'
      image_generator(height: '600', width: '400')
    end
  end
end

Documents/DEV/portfolio-site/app/views/portfolios/_form.html.erb
<%= form_for(@portfolio_item) do |f| %>
  <% if @portfolio_item.errors.any? %>
    <% @portfolio_item.errors.full_messages.each do |error| %>
      <%= alert_generator error %>
    <% end %>
  <% end %>
  
  <div class="row">
    <div class="col-md-6">
      <div class="form-group">
        <%= f.label :title %>
        <%= f.text_field :title, class: 'form-control' %>
      </div>

      <div class="form-group">
        <%= f.label :subtitle %>
        <%= f.text_field :subtitle, class: 'form-control' %>
      </div>

      <div class="form-group">
        <label class="btn btn-primary">
          Upload a main image file <%= f.file_field :main_image, style: 'display:none;' %>
        </label>
      </div>

      <div class="form-group">
        <label class="btn btn-primary">
          Upload a thumb image file <%= f.file_field :thumb_image, style: 'display:none;' %>
        </label>
      </div>
    </div>

    <div class="col-md-6">
      <div class="form-group">
        <%= f.label :body %>
        <%= f.text_area :body, class: 'form-control', rows: 13 %>
      </div>
    </div>
  </div>

  <hr>

  <div class="col-md-12">
    <h2>Technolgies Used:</h2>
    <div>
      <%= f.fields_for :technologies do |technology_form| %>
        <%= render 'technology_fields', f: technology_form %>
      <% end %>

      <div>
        <%= link_to_add_association 'Add Technology', f, :technologies %>
      </div>
    </div>

    <div class="form-group">
      <%= f.submit 'Save Portfolio Item', class: 'btn btn-primary btn-block' %>
    </div>
  </div>
<% end %>

Documents/DEV/portfolio-site/app/views/portfolios/_portfolio_item.html.erb
<div class="col-md-4">
  <div class="card" data-id="<%= portfolio_item.id %>">
    <%= image_tag portfolio_img(portfolio_item.thumb_image, 'thumb'), width: '100%' %>
    <p class="card-text">
      <span><%= link_to portfolio_item.title, portfolio_show_path(portfolio_item) %></span> <%= portfolio_item.subtitle %>
    </p>
  </div>
</div>

Documents/DEV/portfolio-site/app/views/portfolios/_technology_fields.html.erb
<div class="form-group nested-fields">
  <%= f.label :name %>
  <%= f.text_field :name, class: 'form-control' %>
  <%= link_to_remove_association 'Remove Technology', f %>
</div>

Documents/DEV/portfolio-site/app/views/portfolios/angular.html.erb
<h1>Angular Portfolio Items</h1>

<%= link_to "Create New Item", new_portfolio_url if logged_in?(:site_admin) %>

<% @angular_portfolio_items.each do |portfolio_item| %>
  <p><%= link_to portfolio_item.title, portfolio_show_path(portfolio_item) %></p>
  <p><%= portfolio_item.subtitle %></p>
  <p><%= portfolio_item.body %></p>
  <%= image_tag portfolio_item.thumb_image unless portfolio_item.thumb_image.nil? %>
  <%= link_to "Edit", edit_portfolio_path(portfolio_item) if logged_in?(:site_admin) %>
  <%= link_to 'Delete Portfolio Item', portfolio_path(portfolio_item), method: :delete, data: { confirm: 'Are you sure?' } if logged_in?(:site_admin) %>
<% end %>

Documents/DEV/portfolio-site/app/views/portfolios/edit.html.erb
<div class="container portfolio-container">
  <h1>Edit this Portfolio Item</h1>

  <%= render 'form', portfolio_item: @portfolio_item %>
</div>

Documents/DEV/portfolio-site/app/views/portfolios/index.html.erb
<div class="album text-muted">
  <div class="container">
    <%= source_helper("alert alert-warning") %>

    <div class="row <%= "sortable" if logged_in?(:site_admin) %>">
      <%= render partial: 'portfolio_item', collection: @portfolio_items %>
    </div>
  </div>
</div>

Documents/DEV/portfolio-site/app/views/portfolios/new.html.erb
<div class="container portfolio-container">
  <h1>Create a new Portfolio Item</h1>

  <%= render 'form', portfolio_item: @portfolio_item %>  
</div>

Documents/DEV/portfolio-site/app/views/portfolios/show.html.erb
<div class="container portfolio-container">
  <div class="row">
    <div class="col-md-7">
      <%= image_tag portfolio_img(@portfolio_item.main_image, 'main'), width: '100%' %>
    </div>

    <div class="col-md-5">
      <h1><%= @portfolio_item.title %></h1>

      <hr>

      <em><%= @portfolio_item.subtitle %></em>

      <p><%= @portfolio_item.body %></p>

      <hr>

      <h3>Technologies Used:</h3>

      <% @portfolio_item.technologies.each do |t| %>
      <p><%= t.name %></p>
      <% end %>

      <% if logged_in?(:site_admin) %>
        <div class="">
          <%= link_to "Edit Item", edit_portfolio_path(@portfolio_item), class: 'btn btn-warning' %>
        </div>
      <% end %>
    </div>
  </div>
</div>